//+------------------------------------------------------------------+
//|                                                       Nyquist MA |
//|                                                           brax64 |
//|                                                 www.forx-tsd.com |
//+------------------------------------------------------------------+

// Original idea by Dr. Mafred Durschner:
// http://www.vtad.de/node/1441 (in German)

#property copyright "brax64"
#property link      "www.forx-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue 

extern int NMA_Length        = 100;
extern int NMA_Sample_Length = 25;            // Sampling period = 1/4 of NMA_Length
extern int MA_Method         = MODE_LWMA;     //
extern int MA_Price          = PRICE_TYPICAL; //

double nma[],nma_s[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(2);
      SetIndexBuffer(0, nma);  SetIndexLabel(0,"NMA (" + NMA_Length + "," +  NMA_Sample_Length + ")");
      SetIndexBuffer(1, nma_s);
   IndicatorShortName("NMA");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int start()
{
   int i,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

      double Lambda = NMA_Length / NMA_Sample_Length;
      double Alpha  = Lambda * (NMA_Length - 1.0) / (NMA_Length - Lambda);

      //
      //
      //
      //
      //
      
      for (i = limit; i >= 0; i--)  nma_s[i] = iMA(NULL, 0, NMA_Length, 0, MA_Method, MA_Price, i);
      for (i = limit; i >= 0; i--)
      {   
         double Gamma  = iMAOnArray(nma_s,0,NMA_Sample_Length,0,MA_Method,i);
                nma[i] = (Alpha+1.0)*nma_s[i] - Alpha*Gamma;
      }
      return(0);
}